package simulation_Lab12Version;

import java.awt.event.ActionListener;

/**
 * This class encapsulates an animation and some basic services to change the
 * frame rate. The frames that are shown in the animation are specified by a
 * component encapsulated by an ActionListener (and which must be provided to
 * the constructor of this class).
 * 
 * 
 * This app is provided for teaching purposes.
 * 
 * @author mb
 * 
 */
public class SimulationRunnable implements Runnable {
	private final int DEFAULT_FRAME_RATE = 30;
	private int frameRate = DEFAULT_FRAME_RATE;

	private ActionListener dude2;
	private Observee dude1;

	/**
	 * Creates a runnable. The default frame rate is 30 frames per second.
	 */
	public SimulationRunnable(ActionListener frameDrawer) {
		dude2 = frameDrawer;
		dude1 = new Observee(frameRate, dude2);
	}

	/**
	 * Accessor for this animation's frame rate.
	 * 
	 * @return as described above
	 */
	public int getFrameRate() {
		return frameRate;
	}

	/**
	 * Update this animation's frame rate to the passed value. If the passed
	 * value is less than 1 frame per second, or if this animation is already
	 * running, then this animation's frame rate will not be updated.
	 * 
	 * @param targetFrameRate
	 *            the target frame rate
	 * @return true is this animation's frame rate was successfully updated to
	 *         the target framerate, false otherwise
	 */
	public boolean setFrameRate(int targetFrameRate) {
		if (targetFrameRate < 1 || dude1.isRunning()) {
			return false;
		} else {
			frameRate = targetFrameRate;
			dude1 = new Observee(frameRate, dude2);
			return true;
		}
	}

	/**
	 * Causes this runnable to launch. The frame rate will be as specified by
	 * the parameter.
	 * 
	 * @param frameRate
	 */
	public void run(int frameRate) {
		run();
	}

	/**
	 * Causes this runnable to launch. The frame rate will be the default value
	 * for this runnable (1 frame per second).
	 */
	public void run() {
		dude1.start();
	}
}